% Author:
% Date: 23.04.2008

% auswerten(+Term, -AusTerm)

% Term ist eine Konstante
auswerten(T,T) :- atomic(T), !.

% Term ist eine Variable
auswerten(T,T) :- var(T), !.

% allgemein
auswerten(T1,T2) :- T1 =.. [F|Arg], auswerten_liste(Arg,W), T3 =.. [F|W], einfacher(T3,T2),!.

% auswerten_liste
auswerten_liste([],[]) :- !.
auswerten_liste([Arg|Arge],[W|We]) :- auswerten(Arg,W), auswerten_liste(Arge, We).

% einfacher
einfacher(T1 + T2, W) :- number(T1), number(T2), W is T1 + T2.
einfacher(T1 - T2, W) :- number(T1), number(T2), W is T1 - T2.
einfacher(T1 * T2, W) :- number(T1), number(T2), W is T1 * T2.
einfacher(T1 / T2, W) :- number(T1), number(T2), W is T1 / T2.
einfacher(T1 mod T2, W) :- number(T1), number(T2), W is T1 mod T2.
einfacher(-T, W) :- number(T), W is -T.
einfacher(T,T).
